package dr.midlet;
import javax.microedition.lcdui.*;

public class About {
    private About() {};		// no instances

    /**
     * Put up the About box and when the user click ok return
     * to the previous screen.
     */
    public static void showAbout(DriveReporter midlet, Canvas c, Display display) { 
      Runtime rt = Runtime.getRuntime();
      String copyright =
          "This program \"DriveReporter\""
              + " "
              + " Unpublished.\n"
              + "URL: " + midlet.getAppProperty("URL") + '\n'
              + "PId: " + midlet.getAppProperty("pid") + '\n'
              + "Free mem: " + rt.freeMemory() + " B\n"
              + "Total mem: " + rt.totalMemory() + " B\n"
              + "Profiles: " + System.getProperty("microedition.profiles") + '\n'
              + "Config: " + System.getProperty("microedition.configuration") + '\n'
              + "Encoding: " + System.getProperty("microedition.encoding") + '\n'
              + "Locale: " + System.getProperty("microedition.locale") + '\n'
              + "Canvas width: " + c.getWidth() + '\n'
              + "Canvas height: " + c.getHeight() + '\n'
              + "Double buffer: " + c.isDoubleBuffered() + '\n'
              + "Color display: " + display.isColor() + '\n'
              + "Alpha levels: " + display.numAlphaLevels() + '\n'
              + "Colors: " + display.numColors();              

      Alert alert = new Alert("DriveReporter v." + midlet.getAppProperty("MIDlet-Version"));
      alert.setTimeout(Alert.FOREVER);
      
      if (display.numColors() > 2) {
        String icon = (display.isColor())?"/dr/midlet/images/JavaPowered-8.png":"/dr/midlet/images/JavaPowered-2.png";

        try {
          Image image = Image.createImage(icon);
          alert.setImage(image);
        } 
        catch (java.io.IOException x) {
          // just don't append the image.
          System.out.println("Image " + icon + " doesn't exist.");
        }
      }
      // Add the copyright
      alert.setString(copyright);
  
      display.setCurrent(alert);
    }
}
