package dr.midlet;
// import java.util.Vector;
import java.util.Vector;
import java.util.Date;
import javax.microedition.lcdui.*;
import dr.various.Money;

public class DriveForm extends Form implements CommandListener, ItemCommandListener {
  private Command _cmdSave;
  private CommandListener _cl = null;
  private Display _display;
  ChoiceGroup _chgVId;
  private ChoiceGroup _chgDepCiId;
  private TextField _tfDepMeter;
  private DateField _dfDepTime;
  private ChoiceGroup _chgArrCiId;
  private TextField _tfArrMeter;
  private DateField _dfArrTime;
  private TextField _tfMileage;
  private ChoiceGroup _chgPrId;
  private ChoiceGroup _chgComId;
  private ChoiceGroup _chgEId;
  private TextField _tfComment;
  private CityForm _frmCity;
  
  private Command _cmdEnter = new Command("Skriv in", Command.ITEM, 0);
  private Command _cmdNow = new Command("Nu", Command.ITEM, 0);
  private Command _cmdAdd = new Command("Lgg till", Command.OK, 1);
  private Command _cmdCancel = new Command("Avbryt", Command.CANCEL, 2);

  private Drive _drive;
  
  private int[] _cids;
  private int[] _ciids;
  private int[] _comids;
  private int[] _eids;
  private int[] _prids;

  public DriveForm(String title, CommandListener cl, Display d, Command cmdSave) {
    super(title);
    _cl = cl;
    _display = d;
    _cmdSave = cmdSave;
    addCommand(cmdSave);
    setCommandListener(this);
    _chgVId = new ChoiceGroup("Fordon: ", ChoiceGroup.POPUP);
    _chgVId.addCommand(_cmdEnter);
    _chgVId.setItemCommandListener(this);
    _chgDepCiId = new ChoiceGroup("Avg.ort: ", ChoiceGroup.POPUP);
    _chgDepCiId.addCommand(_cmdEnter);
    _chgDepCiId.setItemCommandListener(this);
    _frmCity = new CityForm(this, _cmdAdd, _cmdCancel);
    _tfDepMeter = new TextField("Avg.mtarst. (hm): ", "0", 9, TextField.NUMERIC);
    _dfDepTime = new DateField("Avg.tidpunkt: ", DateField.DATE_TIME);
    _dfDepTime.setDate(new Date());
    _dfDepTime.addCommand(_cmdNow);
    _dfDepTime.setItemCommandListener(this);
    _chgArrCiId = new ChoiceGroup("Ank.ort: ", ChoiceGroup.POPUP);
    _chgArrCiId.addCommand(_cmdEnter);
    _chgArrCiId.setItemCommandListener(this);
    _tfArrMeter = new TextField("Ank.mtarst. (hm): ", "0", 9, TextField.NUMERIC);
    _dfArrTime = new DateField("Ank.tidpunkt: ", DateField.DATE_TIME);
    _dfArrTime.setDate(new Date());
    _dfArrTime.addCommand(_cmdNow);
    _dfArrTime.setItemCommandListener(this);
    _tfMileage = new TextField("Milersttning (kr/mil): ", "", 6, TextField.DECIMAL | TextField.UNEDITABLE); // TODO
    _chgPrId = new ChoiceGroup("Projekt: ", ChoiceGroup.POPUP);
    _chgComId = new ChoiceGroup("Fretag: ", ChoiceGroup.POPUP);
    _chgComId.addCommand(_cmdEnter);
    _chgComId.setItemCommandListener(this);
    _chgEId = new ChoiceGroup("rende: ", ChoiceGroup.POPUP);
    _chgEId.addCommand(_cmdEnter);
    _chgEId.setItemCommandListener(this);
    _tfComment = new TextField("Notering: ", "", 10, TextField.ANY);
    append(_chgVId);
    append(_chgDepCiId);
    append(_tfDepMeter);
    append(_dfDepTime);
    append(_chgArrCiId);
    append(_tfArrMeter);
    append(_dfArrTime);
    append(_tfMileage);
    append(_chgPrId);
    append(_chgComId);
    append(_chgEId);
    append(_tfComment);
  }
  
  public Drive getDrive() {
    return _drive;
  }

  public void commandAction(Command cmd, Displayable d) {
    if(cmd == _cmdSave) {
      try {
        String vid = _chgVId.getString(_chgVId.getSelectedIndex());
        int depciid = _ciids[_chgDepCiId.getSelectedIndex()];
        long depmeter = Long.parseLong(_tfDepMeter.getString());
        long deptime = _dfDepTime.getDate().getTime();
        int arrciid = _ciids[_chgArrCiId.getSelectedIndex()];
        long arrmeter = Long.parseLong(_tfArrMeter.getString());
        long arrtime = _dfArrTime.getDate().getTime();
        int mileage = Money.moneyToInt(_tfMileage.getString());
        int prid = Integer.parseInt(_chgPrId.getString(_chgPrId.getSelectedIndex()));
        int comid = _comids[_chgComId.getSelectedIndex()];
        int eid = _eids[_chgEId.getSelectedIndex()];
        String comment = _tfComment.getString();
        _drive = new Drive(vid, depciid, depmeter, deptime, arrciid, arrmeter, 
          arrtime, mileage, prid, comid, eid, comment);
        _display.setCurrentItem(_chgDepCiId);
      } catch(Exception e) {
        System.out.println(e);
      }
    }
    else if(cmd == _cmdAdd && d == _frmCity) {
      String str = _frmCity._tfCity.getString();
      if(str.length() != 0) {
        ((DriveReporter)_cl).addCity(str, _cids[_frmCity._chgCId.getSelectedIndex()]);
      }
      _display.setCurrent(this); 
      _display.setCurrentItem(_chgDepCiId);
    }
    else if(cmd == _cmdAdd) {
      String str = ((TextBox)d).getString();
      _display.setCurrent(this);
      if(str.length() != 0) {
        if(d.getTitle().startsWith("Fordon")) {
          ((DriveReporter)_cl).addVehicle(str);
          _display.setCurrentItem(_chgVId);
        }
        else if(d.getTitle().startsWith("Fretag")) {
          ((DriveReporter)_cl).addCompany(str);
          _display.setCurrentItem(_chgComId);
        }
        else if(d.getTitle().startsWith("rende")) {
          ((DriveReporter)_cl).addErrand(str);
          _display.setCurrentItem(_chgEId);
        }
      }
    }
    else if(cmd == _cmdCancel) {
      _display.setCurrent(this); 
      _display.setCurrentItem(_chgDepCiId);
    }
    _cl.commandAction(cmd, d);
  }
   
  public void commandAction(Command cmd, Item item) {
    if(cmd == _cmdNow) {
      ((DateField)item).setDate(new Date());
    }
    else if(cmd == _cmdEnter && (item == _chgDepCiId || item == _chgArrCiId)) {
      _display.setCurrent(_frmCity);
    }
    else if(cmd == _cmdEnter) {
      TextBox tbAdd = null;
      if(item == _chgVId) {
        tbAdd = new TextBox("Fordon", "", 7, TextField.ANY | TextField.INITIAL_CAPS_WORD);
      }
      else if(item == _chgComId) {
        tbAdd = new TextBox("Fretag", "", 10, TextField.ANY | TextField.INITIAL_CAPS_WORD);
      }
      else if(item == _chgEId) {
        tbAdd = new TextBox("rende", "", 10, TextField.ANY | TextField.INITIAL_CAPS_WORD);
      }
      tbAdd.addCommand(_cmdAdd);
      tbAdd.addCommand(_cmdCancel);
      tbAdd.setCommandListener(this);
      _display.setCurrent(tbAdd);
    }
  }
  
  public void reloadCountries(Vector countryIds) {
    _frmCity._chgCId.deleteAll();
    int noOfItems = countryIds.size();
    _cids = new int[noOfItems];
    int nCIdCount = 0;
    for(int i = 0, id; i < noOfItems; ++i) {
      id = ((Integer)countryIds.elementAt(i)).intValue();
      Country item = (Country)((DriveReporter)_cl)._rmsdbCountry.getRecord(id);
      _cids[i] = item.getDRId();
      _frmCity._chgCId.append(item.getCountry(), null);
      if(item.getInDB()) {
        ++nCIdCount;
      }
    }
    ((DriveReporter)_cl).setCIdCount(nCIdCount);
  }
  
  public void reloadCities(Vector cityIds) {
    _chgDepCiId.deleteAll();
    _chgArrCiId.deleteAll();
    int noOfItems = cityIds.size();
    _ciids = new int[noOfItems];
    int nCiIdCount = 0;
    for(int i = 0, id; i < noOfItems; ++i) {
      id = ((Integer)cityIds.elementAt(i)).intValue();
      City item = (City)((DriveReporter)_cl)._rmsdbCity.getRecord(id);
      _ciids[i] = item.getDRId();
      _chgDepCiId.append(item.getCity(), null);
      _chgArrCiId.append(item.getCity(), null);
      if(item.getInDB()) {
        ++nCiIdCount;
      }
    }
    ((DriveReporter)_cl).setCiIdCount(nCiIdCount);
  }

  public void reloadCompanies(Vector companyIds) {
    _chgComId.deleteAll();
    int noOfItems = companyIds.size();
    _comids = new int[noOfItems];
    int nComIdCount = 0;
    for(int i = 0, id; i < noOfItems; ++i) {
      id = ((Integer)companyIds.elementAt(i)).intValue();
      Company item = (Company)((DriveReporter)_cl)._rmsdbCompany.getRecord(id);
      _comids[i] = item.getDRId();
      _chgComId.append(item.getCompany(), null);
      if(item.getInDB()) {
        ++nComIdCount;
      }
    }
    ((DriveReporter)_cl).setComIdCount(nComIdCount);
  }

  public void reloadErrands(Vector errandIds) {
    _chgEId.deleteAll();
    int noOfItems = errandIds.size();
    _eids = new int[noOfItems];
    int nEIdCount = 0;
    for(int i = 0, id; i < noOfItems; ++i) {
      id = ((Integer)errandIds.elementAt(i)).intValue();
      Errand item = (Errand)((DriveReporter)_cl)._rmsdbErrand.getRecord(id);
      _eids[i] = item.getDRId();
      _chgEId.append(item.getErrand(), null);
      if(item.getInDB()) {
        ++nEIdCount;
      }
    }
    ((DriveReporter)_cl).setEIdCount(nEIdCount);
  }
  
  public void reloadProjects(Vector projectIds) {
    _chgPrId.deleteAll();
    int noOfItems = projectIds.size();
    _prids = new int[noOfItems];
    for(int i = 0, id; i < noOfItems; ++i) {
      id = ((Integer)projectIds.elementAt(i)).intValue();
      Project item = (Project)((DriveReporter)_cl)._rmsdbProject.getRecord(id);
      _prids[i] = item.getDRId();
      _chgPrId.append(String.valueOf(item.getDRId()), null);
    }
  }
  
  public void reloadMileages(Vector mileageIds) {
    int noOfItems = mileageIds.size();
    for(int i = 0, id; i < noOfItems; ++i) {
      id = ((Integer)mileageIds.elementAt(i)).intValue();
      Mileage rec = (Mileage)((DriveReporter)_cl)._rmsdbMileage.getRecord(id);
      _tfMileage.setString(Money.intToMoney(rec.getDRId()));
    }
  }
}