package dr.midlet;
// import javax.microedition.midlet.*;
import dr.rms.stream.RMSManagerStream;
import dr.various.URLUTF8Encoder;
import java.io.*;
import java.util.Hashtable;
import java.util.Vector;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;
import net.mypapit.java.StringTokenizer; 
// From: http://mobilepit.com/06/solution-stringtokenizer-in-j2me-javame-midlets.html
import dr.rms.stream.*;

public class DriveReporter
     extends javax.microedition.midlet.MIDlet
     implements CommandListener, Runnable  {
  private Display _display;
  private RefuelForm _frmRefuel;
  DriveForm _frmDrive;
  private Displayable _frmSave;
  private Canvas _canvas;

  // Model {
  RMSManagerFuel _rmsdbFuel = null;
  RMSManagerVehicle _rmsdbVehicle = null;
  private RMSManagerRefuel _rmsdbRefuel = null;
  RMSManagerCountry _rmsdbCountry = null;
  RMSManagerCity _rmsdbCity = null;
  RMSManagerCompany _rmsdbCompany = null;
  RMSManagerErrand _rmsdbErrand = null;
  RMSManagerProject _rmsdbProject = null;
  RMSManagerMileage _rmsdbMileage = null;
  private RMSManagerDrive _rmsdbDrive = null;
  
  private Vector _fuelIds;
  private Vector _vehicleIds;
  private Vector _refuelIds;
  private Vector _countryIds;
  private Vector _cityIds;
  private Vector _companyIds;
  private Vector _errandIds;
  private Vector _projectIds;
  private Vector _mileageIds;
  private Vector _driveIds;
  
  private int _nFIdCount = 0;
  private int _nCIdCount = 0;
  private int _nCiIdCount = 0;
  private int _nComIdCount = 0;
  private int _nEIdCount = 0;
  // }

  private int _cmd;
  private final int PUT_FUELS =     91850;
  private final int PUT_VEHICLES =  918750;
  private final int REFUEL =        485;
  private final int PUT_COUNTRIES = 9172140;
  private final int PUT_CITIES =    91010;
  private final int PUT_COMPANIES = 9173920;
  private final int PUT_ERRANDS =   9144210;
  private final int DRIVE =         148;
  private final int GET_FUELS =     71850;
  private final int GET_VEHICLES =  718750;
  private final int GET_COUNTRIES = 7172140;
  private final int GET_CITIES =    71010;
  private final int GET_COMPANIES = 7173920;
  private final int GET_ERRANDS =   7144210;
  private final int GET_PROJECTS =  71946710;
  private final int GET_MILEAGES =  713570;

  private Command _cmdExit  =  new Command("Avsluta",  Command.EXIT, 2);
  private Command _cmdDrive =  new Command("Krning", Command.OK, 1);
  private Command _cmdRefuel = new Command("Tankning", Command.OK, 1);
  private Command _cmdSave =   new Command("Lagra i telefon", Command.OK, 3);
  private Command _cmdSend =   new Command("Ladda upp lagrade", Command.OK, 4);
  private Command _cmdUpdate = new Command("Uppdatera valbara", Command.OK, 5);
  private Command _cmdAbout =  new Command("Om DriveReporter", Command.OK, 6);
  private Command _cmdBack =   new Command("Tillbaka", Command.BACK, 2);
  
  // TODO: What happens if Update is choosen before Send. That would remove
  //       entered choices.
  
  public DriveReporter() {
    try {
      _rmsdbFuel = new RMSManagerFuel("Fuels", null, null);
      _rmsdbFuel.openDB();
      _rmsdbVehicle = new RMSManagerVehicle("Vehicles", null, null);
      _rmsdbVehicle.openDB();
      _rmsdbRefuel = new RMSManagerRefuel("Refuels", null, null);
      _rmsdbRefuel.openDB();
      _rmsdbCountry = new RMSManagerCountry("Countries", null, null);
      _rmsdbCountry.openDB();
      _rmsdbCity = new RMSManagerCity("Cities", null, null);
      _rmsdbCity.openDB();
      _rmsdbCompany = new RMSManagerCompany("Companies", null, null);
      _rmsdbCompany.openDB();
      _rmsdbErrand = new RMSManagerErrand("Errands", null, null);
      _rmsdbErrand.openDB();
      _rmsdbProject = new RMSManagerProject("Projects", null, null);
      _rmsdbProject.openDB();
      _rmsdbMileage = new RMSManagerMileage("Mileages", null, null);
      _rmsdbMileage.openDB();
      _rmsdbDrive = new RMSManagerDrive("Drives", null, null);
      _rmsdbDrive.openDB();
    }
    catch(Exception e) {
      System.out.println("Error opening RMS-databases.");
    }
    initItems();
  }

  public void startApp() {
    if(_display == null) {
      initMIDlet();  
    }
  }

  public void pauseApp() { 
  }

  public void destroyApp(boolean unconditional) { 
    try {
      _rmsdbFuel.closeDB();
      _rmsdbVehicle.closeDB();
      _rmsdbRefuel.closeDB();
      _rmsdbCountry.closeDB();
      _rmsdbCity.closeDB();
      _rmsdbCompany.closeDB();
      _rmsdbErrand.closeDB();
      _rmsdbProject.closeDB();
      _rmsdbMileage.closeDB();
      _rmsdbDrive.closeDB();
    } catch(Exception e) {
      System.out.println("Can't close rmsdbs.");
    }
    exitMIDlet();
  }

  private void initMIDlet() {
    _display = Display.getDisplay(this);
    _frmRefuel = new RefuelForm("Tankning", this, _display, _cmdSave);
    _frmRefuel.addCommand(_cmdExit);
    _frmRefuel.addCommand(_cmdDrive);
    _frmRefuel.addCommand(_cmdSend);
    _frmRefuel.addCommand(_cmdUpdate);
    _frmRefuel.addCommand(_cmdAbout);
    _frmDrive = new DriveForm("Krning", this, _display, _cmdSave);
    _frmDrive.addCommand(_cmdExit);
    _frmDrive.addCommand(_cmdRefuel);
    _frmDrive.addCommand(_cmdSend);
    _frmDrive.addCommand(_cmdUpdate);
    _frmDrive.addCommand(_cmdAbout);
    
    if(_fuelIds.size() == 0 || _vehicleIds.size() == 0 || _countryIds.size() == 0 
      || _cityIds.size() == 0 || _companyIds.size() == 0 || _errandIds.size() == 0 
      || _projectIds.size() == 0 || _mileageIds.size() == 0) {
      updateFromServer(GET_FUELS);
    } 
    else {
      _frmRefuel.reloadFuels(_fuelIds);
      _frmRefuel.reloadVehicles(_vehicleIds);
      _frmDrive.reloadCountries(_countryIds);
      _frmDrive.reloadCities(_cityIds);
      _frmDrive.reloadCompanies(_companyIds);
      _frmDrive.reloadErrands(_errandIds);
      _frmDrive.reloadProjects(_projectIds);
      _frmDrive.reloadMileages(_mileageIds);
    }
    _canvas = new SplashScreen(_display, _frmDrive);
  }
  
  private void exitMIDlet() {
    notifyDestroyed();
  }

  public void initItems() {
    _vehicleIds = initItem(_rmsdbVehicle);
    _fuelIds = initItem(_rmsdbFuel);
    _refuelIds = initItem(_rmsdbRefuel);
    _countryIds = initItem(_rmsdbCountry);
    _cityIds = initItem(_rmsdbCity);
    _companyIds = initItem(_rmsdbCompany);
    _errandIds = initItem(_rmsdbErrand);
    _projectIds = initItem(_rmsdbProject);
    _mileageIds = initItem(_rmsdbMileage);
    _driveIds = initItem(_rmsdbDrive);
  }
  
  private Vector initItem(RMSManagerStream rmsdb) {
    RecordEnumeration records;
    Vector ids = new Vector();
    try {
      records = rmsdb.enumerate();
      for(int i = 0; records.hasNextElement(); ++i) {
        int id = records.nextRecordId();
        ids.addElement(new Integer(id));
      }
    } catch(Exception e) {
      System.out.println(e);
    }
    return ids;
  }
  
  public void commandAction(Command c, 
                            Displayable d) {
    if(c == _cmdExit) {
      this.exitMIDlet();
    }
    else if(c == _cmdRefuel) {
      _display.setCurrent(_frmRefuel);
    }
    else if(c == _cmdDrive) {
      _display.setCurrent(_frmDrive);
    }
    else if(c == _cmdSend) {
      updateFromServer(PUT_FUELS);
    }
    else if(c == _cmdUpdate) {
      updateFromServer(GET_FUELS);
    }
    else if(c == _cmdAbout) {
      About.showAbout(this, _canvas, _display);
    }
    else if(d == _frmRefuel) {
      this.commandActionRefuelForm(c);
    } 
    else if(d == _frmDrive) {
      this.commandActionDriveForm(c);
    }
  }
  
  private void commandActionRefuelForm(Command c) {

    if(c == _cmdSave) {
      if(_frmRefuel.getRefuel() != null) {
        Integer id = new Integer(_rmsdbRefuel.insertRecord(_frmRefuel.getRefuel()));
        _refuelIds.addElement(id);
        Alert a = new Alert("Tankning lagrad!");
        a.setTimeout(1000);
        _display.setCurrent(a);
      }
    }
  }
  
  private void commandActionDriveForm(Command c) {
    if(c == _cmdSave) {
      if(_frmDrive.getDrive() != null) {
        Integer id = new Integer(_rmsdbDrive.insertRecord(_frmDrive.getDrive()));
        _driveIds.addElement(id);
        Alert a = new Alert("Krning lagrad!");
        a.setTimeout(1000);
        _display.setCurrent(a);
      }
    }
  }
  
  void addVehicle(String str) {
    Vehicle v = new Vehicle(false, str);
    int id = _rmsdbVehicle.insertRecord(v);
    _vehicleIds.addElement(new Integer(id));
    _frmRefuel.reloadVehicles(_vehicleIds);
  }
  
  void addFuel(String str) {
    ++_nFIdCount;
    Fuel f = new Fuel(false, -_nFIdCount, str);
    int id = _rmsdbFuel.insertRecord(f);
    _fuelIds.addElement(new Integer(id));
    _frmRefuel.reloadFuels(_fuelIds);
  }
  
  void addCountry(String str) {
    ++_nCIdCount;
    Country c = new Country(false, -_nCIdCount, str);
    int id = _rmsdbCountry.insertRecord(c);
    _countryIds.addElement(new Integer(id));
    _frmDrive.reloadCountries(_countryIds);
  }

  void addCity(String str, int cid) {
    ++_nCiIdCount;
    City c = new City(false, -_nCiIdCount, str, cid);
    int id = _rmsdbCity.insertRecord(c);
    _cityIds.addElement(new Integer(id));
    _frmDrive.reloadCities(_cityIds);
  }
  
  void addCompany(String str) {
    ++_nComIdCount;
    Company c = new Company(false, -_nComIdCount, str);
    int id = _rmsdbCompany.insertRecord(c);
    _companyIds.addElement(new Integer(id));
    _frmDrive.reloadCompanies(_companyIds);
  }
  
  void addErrand(String str) {
    ++_nEIdCount;
    Errand e = new Errand(false, -_nEIdCount, str);
    int id = _rmsdbErrand.insertRecord(e);
    _errandIds.addElement(new Integer(id));
    _frmDrive.reloadErrands(_errandIds);
  }
  
  void setFIdCount(int nFIdCount) {
    _nFIdCount = nFIdCount;
  }
  
  void setCIdCount(int nCIdCount) {
    _nCIdCount = nCIdCount;
  }
  
  void setCiIdCount(int nCiIdCount) {
    _nCiIdCount = nCiIdCount;
  }
  
  void setComIdCount(int nComIdCount) {
    _nComIdCount = nComIdCount;
  }
  
  void setEIdCount(int nEIdCount) {
    _nEIdCount = nEIdCount;
  }
   
  private void updateFromServer(int cmd) {
    _cmd = cmd;
    Form frmWait = new Form("Kommunicerar med server...");
    _frmSave = _display.getCurrent();
    _display.setCurrent(frmWait);
    Thread t = new Thread(this);
    t.start();
  }
  
  public void run() {
    connect();
    _display.setCurrent(_frmSave);
  }
  
  private synchronized void connect() {
    String url = this.getAppProperty("URL");
    String query;
    String str;
    int noOfItems;
    Hashtable htFId = new Hashtable();
    Hashtable htCId = new Hashtable();
    Hashtable htCiId = new Hashtable();
    Hashtable htComId = new Hashtable();
    Hashtable htEId = new Hashtable();
    switch(_cmd) {
      case PUT_FUELS:
        noOfItems = _fuelIds.size();
        for(int i = 0, id; i < noOfItems; ++i) {
          id = ((Integer)_fuelIds.elementAt(i)).intValue();
          Fuel f = (Fuel)_rmsdbFuel.getRecord(id);
          if(!f.getInDB()) {
            query = "cmd=" + PUT_FUELS + "&fuel=" + URLUTF8Encoder.encode(f.getFuel());
            str = transfer(url, query);
            updateDrId(_rmsdbFuel, id, htFId, str, f);
          } // if
        } // for
        _frmRefuel.reloadFuels(_fuelIds);
        // break;      
      case PUT_VEHICLES:
        int pid = Integer.parseInt(getAppProperty("pid"));
        noOfItems = _vehicleIds.size();
        for(int i = 0, id; i < noOfItems; ++i) {
          id = ((Integer)_vehicleIds.elementAt(i)).intValue();
          Vehicle v = (Vehicle)_rmsdbVehicle.getRecord(id);
          if(!v.getInDB()) {
            query = "cmd=" + PUT_VEHICLES + "&vid=" 
              + URLUTF8Encoder.encode(v.getVehicle()) + "&pid=" + pid;
            str = transfer(url, query);
            v.setInDB(true);
            _rmsdbVehicle.updateRecord(id, v);
          } // if
        } // for
        _frmRefuel.reloadVehicles(_vehicleIds);      
        // break;
      case REFUEL:
        noOfItems = _refuelIds.size();
        for(int i = 0, id; i < noOfItems; ++i) {
          id = ((Integer)_refuelIds.elementAt(i)).intValue();
          Refuel rf = (Refuel)_rmsdbRefuel.getRecord(id);
          int fid = rf.getFId();
          if(fid < 0) {
            Integer newFid = (Integer)htFId.get(new Integer(fid));
            fid = newFid.intValue(); 
          }
          query = "cmd=" + REFUEL + 
            "&vid=" + URLUTF8Encoder.encode(rf.getVId()) + "&pid=" + getAppProperty("pid") 
            + "&rftime=" + rf.getRfTime() + "&price=" +  rf.getPrice() 
            + "&volume=" + rf.getVolume() +  "&level=" + rf.getLevel() 
            + "&fid=" + fid + "&meter=" + rf.getMeter();
          str = transfer(url, query);
          _rmsdbRefuel.deleteRecord(id);
        }
        _refuelIds.removeAllElements();
        // break;
      case PUT_COUNTRIES:
        noOfItems = _countryIds.size();
        for(int i = 0, id; i < noOfItems; ++i) {
          id = ((Integer)_countryIds.elementAt(i)).intValue();
          Country c = (Country)_rmsdbCountry.getRecord(id);
          if(!c.getInDB()) {
            query = "cmd=" + PUT_COUNTRIES 
              + "&country=" + URLUTF8Encoder.encode(c.getCountry());
            str = transfer(url, query); 
            updateDrId(_rmsdbCountry, id, htCId, str, c);
          } // if
        } // for
        _frmDrive.reloadCountries(_countryIds);      
        // break;
      case PUT_CITIES:
        noOfItems = _cityIds.size();
        for(int i = 0, id; i < noOfItems; ++i) {
          id = ((Integer)_cityIds.elementAt(i)).intValue();
          City c = (City)_rmsdbCity.getRecord(id);
          if(!c.getInDB()) {
            query = "cmd=" + PUT_CITIES 
              + "&city=" + URLUTF8Encoder.encode(c.getCity())
              + "&cid=" + c.getCId();
            str = transfer(url, query); 
            updateDrId(_rmsdbCity, id, htCiId, str, c);
          } // if
        } // for
        _frmDrive.reloadCities(_cityIds);      
        // break;
      case PUT_COMPANIES:
        noOfItems = _companyIds.size();
        for(int i = 0, id; i < noOfItems; ++i) {
          id = ((Integer)_companyIds.elementAt(i)).intValue();
          Company c = (Company)_rmsdbCompany.getRecord(id);
          if(!c.getInDB()) {
            query = "cmd=" + PUT_COMPANIES 
              + "&company=" + URLUTF8Encoder.encode(c.getCompany());
            str = transfer(url, query); 
            updateDrId(_rmsdbCompany, id, htComId, str, c);
          } // if
        } // for
        _frmDrive.reloadCompanies(_companyIds);
        // break;
      case PUT_ERRANDS:
        noOfItems = _errandIds.size();
        for(int i = 0, id; i < noOfItems; ++i) {
          id = ((Integer)_errandIds.elementAt(i)).intValue();
          Errand ea = (Errand)_rmsdbErrand.getRecord(id);
          if(!ea.getInDB()) {
            query = "cmd=" + PUT_ERRANDS 
              + "&errand=" + URLUTF8Encoder.encode(ea.getErrand());
            str = transfer(url, query);
            updateDrId(_rmsdbErrand, id, htEId, str, ea);
          } // if
        } // for
        _frmDrive.reloadErrands(_errandIds);
        // break;
      case DRIVE:
        noOfItems = _driveIds.size();
        for(int i = 0, id; i < noOfItems; ++i) {
          id = ((Integer)_driveIds.elementAt(i)).intValue();
          Drive d = (Drive)_rmsdbDrive.getRecord(id);
          int depciid = d.getDepCiId();
          if(depciid < 0) {
            Integer newCiId = (Integer)htCiId.get(new Integer(depciid));
            depciid = newCiId.intValue();
          }
          int arrciid = d.getArrCiId();
          if(arrciid < 0) {
            Integer newCiId = (Integer)htCiId.get(new Integer(arrciid));
            arrciid = newCiId.intValue();
          }
          int comid = d.getComId();
          if(comid < 0) {
            Integer newComId = (Integer)htComId.get(new Integer(comid));
            comid = newComId.intValue();
          }
          int eid = d.getEId();
          if(eid < 0) {
            Integer newEId = (Integer)htEId.get(new Integer(eid));
            eid = newEId.intValue();
          }
          query = "cmd=" + DRIVE 
            + "&vid=" + URLUTF8Encoder.encode(d.getVId()) + "&depciid=" + depciid 
            + "&depmeter=" + d.getDepMeter() + "&deptime=" + d.getDepTime() 
            + "&arrciid=" + arrciid + "&arrmeter=" + d.getArrMeter() 
            + "&arrtime=" + d.getArrTime() + "&mileage=" + d.getMileage() 
            + "&pid=" + getAppProperty("pid") + "&prid=" + d.getPrId() 
            + "&comid=" + comid + "&eid=" + eid 
            + "&comment=" + URLUTF8Encoder.encode(d.getComment());
          str = transfer(url, query);
          _rmsdbDrive.deleteRecord(id);
        }
        _driveIds.removeAllElements();      
        break;
      case GET_FUELS:
        query = "cmd=" + GET_FUELS;
        str = transfer(url, query);
        try {
          StringTokenizer st = new StringTokenizer(str, ";\r\n");
          if(st.hasMoreTokens()) {
            deleteRecordsInDB(_rmsdbFuel, _fuelIds);
            while(st.hasMoreTokens()) { 
              int fid = Integer.parseInt(st.nextToken());
              String fuel = st.nextToken();
              Fuel item = new Fuel(true, fid, fuel);
              Integer id = new Integer(_rmsdbFuel.insertRecord(item));
              _fuelIds.addElement(id);
              System.out.println(fuel);
            }        
          }
          _frmRefuel.reloadFuels(_fuelIds);
        } catch(Exception e) {
          System.out.println("Error: '"+ e.getMessage() + "'");
        }
        //break;     
      case GET_VEHICLES:
        query = "cmd=" + GET_VEHICLES 
          + "&pid=" + getAppProperty("pid");
        str = transfer(url, query);
        try {
          StringTokenizer st = new StringTokenizer(str, ";\r\n");
          if(st.hasMoreTokens()) {
            deleteRecordsInDB(_rmsdbVehicle, _vehicleIds);
            while(st.hasMoreTokens()) { 
              String vid = st.nextToken();
              Vehicle item = new Vehicle(true, vid);
              Integer id = new Integer(_rmsdbVehicle.insertRecord(item));
              _vehicleIds.addElement(id);
              System.out.println(vid);
            }        
          }
          _frmRefuel.reloadVehicles(_vehicleIds);
        } catch(Exception e) {
          System.out.println("Error: '"+ e.getMessage() + "'");
        }
        // break;       
      case GET_COUNTRIES:
        query = "cmd=" + GET_COUNTRIES;
        str = transfer(url, query);
        try {
          StringTokenizer st = new StringTokenizer(str, ";\r\n");
          if(st.hasMoreTokens()) {
            deleteRecordsInDB(_rmsdbCountry, _countryIds);
            while(st.hasMoreTokens()) { 
              int cid = Integer.parseInt(st.nextToken());
              String country = st.nextToken();
              Country item = new Country(true, cid, country);
              Integer id = new Integer(_rmsdbCountry.insertRecord(item));
              _countryIds.addElement(id);
              System.out.println(country);
            }        
          }
          _frmDrive.reloadCountries(_countryIds);
        } catch(Exception e) {
          System.out.println("GET_COUNTRIES Error: '"+ e.getMessage() + "'");
        }
        //break;
      case GET_CITIES:
        query = "cmd=" + GET_CITIES;
        str = transfer(url, query);
        try {
          StringTokenizer st = new StringTokenizer(str, ";\r\n");
          if(st.hasMoreTokens()) {
            deleteRecordsInDB(_rmsdbCity, _cityIds);
            while(st.hasMoreTokens()) { 
              int ciid = Integer.parseInt(st.nextToken());
              String city = st.nextToken();
              int cid = Integer.parseInt(st.nextToken());
              City item = new City(true, ciid, city, cid);
              Integer id = new Integer(_rmsdbCity.insertRecord(item));
              _cityIds.addElement(id);
              System.out.println(city);
            }        
          }
          _frmDrive.reloadCities(_cityIds);
        } catch(Exception e) {
          System.out.println("GET_CITIES Error: '"+ e.getMessage() + "'");
        }
        //break;
      case GET_COMPANIES:
        query = "cmd=" + GET_COMPANIES;
        str = transfer(url, query);
        try {
          StringTokenizer st = new StringTokenizer(str, ";\r\n");
          if(st.hasMoreTokens()) {
            deleteRecordsInDB(_rmsdbCompany, _companyIds);
            while(st.hasMoreTokens()) { 
              int comid = Integer.parseInt(st.nextToken());
              String company = st.nextToken();
              Company item = new Company(true, comid, company);
              Integer id = new Integer(_rmsdbCompany.insertRecord(item));
              _companyIds.addElement(id);
              System.out.println(company);
            }        
          }
          _frmDrive.reloadCompanies(_companyIds);
        } catch(Exception e) {
          System.out.println("Error: '"+ e.getMessage() + "'");
        }
        //break;
      case GET_ERRANDS:
        query = "cmd=" + GET_ERRANDS;
        str = transfer(url, query);
        try {
          StringTokenizer st = new StringTokenizer(str, ";\r\n");
          if(st.hasMoreTokens()) {
            deleteRecordsInDB(_rmsdbErrand, _errandIds);
            while(st.hasMoreTokens()) { 
              int eid = Integer.parseInt(st.nextToken());
              String errand = st.nextToken();
              Errand item = new Errand(true, eid, errand);
              Integer id = new Integer(_rmsdbErrand.insertRecord(item));
              _errandIds.addElement(id);
              System.out.println(errand);
            }        
          }
          _frmDrive.reloadErrands(_errandIds);
        } catch(Exception e) {
          System.out.println("Error: '"+ e.getMessage() + "'");
        }
        // break;
      case GET_PROJECTS:
        query = "cmd=" + GET_PROJECTS 
          + "&pid=" + getAppProperty("pid");
        str = transfer(url, query);
        try {
          StringTokenizer st = new StringTokenizer(str, ";\r\n");
          if(st.hasMoreTokens()) {
            deleteRecordsInDB(_rmsdbProject, _projectIds);
            while(st.hasMoreTokens()) { 
              int prid = Integer.parseInt(st.nextToken());
              Project item = new Project(prid);
              Integer id = new Integer(_rmsdbProject.insertRecord(item));
              _projectIds.addElement(id);
              System.out.println(prid);
            }        
          }
          _frmDrive.reloadProjects(_projectIds);
        } catch(Exception e) {
          System.out.println("Error: '"+ e.getMessage() + "'");
        }
        // break;
      case GET_MILEAGES:
        query = "cmd=" + GET_MILEAGES;
        str = transfer(url, query);
        try {
          StringTokenizer st = new StringTokenizer(str, ";\r\n");
          if(st.hasMoreTokens()) {
            deleteRecordsInDB(_rmsdbMileage, _mileageIds);
            while(st.hasMoreTokens()) { 
              int mileage = Integer.parseInt(st.nextToken());
              Mileage rec = new Mileage(mileage);
              Integer id = new Integer(_rmsdbMileage.insertRecord(rec));
              _mileageIds.addElement(id);
              System.out.println(mileage);
            }        
          }
          _frmDrive.reloadMileages(_mileageIds);
        } catch(Exception e) {
          System.out.println("Error: '"+ e.getMessage() + "'");
        }
        break;
    }  
  }
  
  String transfer(String url, String query) {
    HttpConnection hc = null;
    InputStream is = null;
    String str = null;
    try {
      hc = (HttpConnection)Connector.open(url + '?' + query);
      is = hc.openInputStream();
      if(hc.getResponseCode() == HttpConnection.HTTP_OK) {
        int length = (int)hc.getLength();
        if(length != -1) {
          byte servletData[] = new byte[length];
          is.read(servletData);
          str = new String(servletData);
        }
        else {
          ByteArrayOutputStream bs = new ByteArrayOutputStream();
          int ch;
          while((ch = is.read()) != -1)
            bs.write(ch);
          str = new String(bs.toByteArray());
          bs.close();
        }
      }
    } catch(Exception e) {
      System.out.println(e.getMessage());
    } finally {
      try {
        if(is != null)
          is.close();
        if(hc != null)
          hc.close();
      } catch(Exception e) {
        System.out.println(e.getMessage());
      } 
    }
    return str;
  }
  
  private DRItem getDRItem(RMSManagerStream rmsdb, Vector rmsIds, int i) {
    int id = ((Integer)rmsIds.elementAt(i)).intValue();
    return rmsdb.getRecord(id);
  }
  
  private void updateDrId(RMSManagerStream rmsdb, int rmsId, Hashtable ht, 
    String str, DRItem dritem) {
    try {
      StringTokenizer st = new StringTokenizer(str, ";\r\n");
      if(st.hasMoreTokens()) {
        int oldDRId = dritem.getDRId();
        dritem.setDRId(Integer.parseInt(st.nextToken()));
        dritem.setInDB(true);
        rmsdb.updateRecord(rmsId, dritem);
        ht.put(new Integer(oldDRId), new Integer(dritem.getDRId()));
      }        
    } catch(Exception e) {
       System.out.println("Error: '"+ e.getMessage() + "'");
    }
  }       
  
  private void deleteRecordsInDB(RMSManagerStream rmsdb, Vector rmsIds) {
    for(int i = rmsIds.size()-1; i >= 0; --i) {
      int id = ((Integer)rmsIds.elementAt(i)).intValue();  
      if(rmsdb.getRecord(id).getInDB()) {
        rmsdb.deleteRecord(id);
        rmsIds.removeElementAt(i);
      }
    }
  }
}
