package dr.midlet;
import java.util.Vector;
import java.util.Date;
import javax.microedition.lcdui.*;
import dr.various.Money;

public class RefuelForm extends Form implements CommandListener, ItemCommandListener {
  private Command _cmdSave;
  private CommandListener _cl = null;
  private Display _display;
  private RefuelForm _frmRefuel;
  private ChoiceGroup _chgVId;
  private DateField _dfRFTime;
  private TextField _tfPrice;
  private TextField _tfVolume;
  private TextField _tfLevel;
  private ChoiceGroup _chgFId;
  private TextField _tfMeter;
  private Command _cmdEnter = new Command("Skriv in", Command.ITEM, 0);
  private Command _cmdNow = new Command("Nu", Command.OK, 0);
  
  private Refuel _refuel;
  
  private int[] _fids;

  public RefuelForm(String title, CommandListener cl, Display d, Command cmdSave) {
    super(title);
    _cl = cl;
    _display = d;
    _cmdSave = cmdSave;
    addCommand(cmdSave);
    setCommandListener(this);
    _chgVId = new ChoiceGroup("Fordon: ", ChoiceGroup.POPUP);
    _chgVId.addCommand(_cmdEnter);
    _chgVId.setItemCommandListener(this);
    _dfRFTime = new DateField("Tidpunkt: ", DateField.DATE_TIME);
    _dfRFTime.setDate(new Date());
    _dfRFTime.addCommand(_cmdNow);
    _dfRFTime.setItemCommandListener(this);
    _tfPrice = new TextField("Pris (kr): ", "11.00", 6, TextField.DECIMAL);
    _tfVolume = new TextField("Volym (l): ", "5.00", 6, TextField.DECIMAL);
    _tfLevel = new TextField("Niv (%): ", "100", 3, TextField.NUMERIC);
    _chgFId = new ChoiceGroup("Brnsle: ", ChoiceGroup.POPUP);
    _chgFId.addCommand(_cmdEnter);
    _chgFId.setItemCommandListener(this);
    _tfMeter = new TextField("Mtarst. (hm): ", "0", 9, TextField.NUMERIC);
    append(_chgVId);
    append(_dfRFTime);
    append(_tfPrice);
    append(_tfVolume);
    append(_tfLevel);
    append(_chgFId);
    append(_tfMeter);
    _frmRefuel = this;
  }
  
  public Refuel getRefuel() {
    return _refuel;
  }
  
  public void commandAction(Command cmd, Displayable d) {
    if(cmd == _cmdSave) {
      String vid = _chgVId.getString(_chgVId.getSelectedIndex());
      long rftime = _dfRFTime.getDate().getTime();
      int price = Money.moneyToInt(_tfPrice.getString());
      int volume = Money.moneyToInt(_tfVolume.getString());
      byte level = Byte.parseByte(_tfLevel.getString());
      int fid = _fids[_chgFId.getSelectedIndex()];
      long meter = Long.parseLong(_tfMeter.getString());
      _refuel = new Refuel(vid, rftime, price, volume, level, fid, meter);
      _display.setCurrentItem(_dfRFTime);
    }
    _cl.commandAction(cmd, d);
  }
  
  Command _cmdAdd = new Command("Lgg till", Command.OK, 1);
  Command _cmdCancel = new Command("Avbryt", Command.CANCEL, 2);
  
  public void commandAction(Command cmd, Item item) {
    if(cmd == _cmdNow) {
      _dfRFTime.setDate(new Date());
    }
    else if(cmd == _cmdEnter) {
      TextBox tbAdd = null;
      if(item == _chgVId) {
        tbAdd = new TextBox("Fordon", "", 7, TextField.ANY | TextField.INITIAL_CAPS_WORD);
      }
      else if(item == _chgFId) {
        tbAdd = new TextBox("Brnsle", "", 15, TextField.ANY);
      }
      tbAdd.addCommand(_cmdAdd);
      tbAdd.addCommand(_cmdCancel);
      tbAdd.setCommandListener(new CommandListener() {
        public void commandAction(Command cmd, Displayable d) {
          if(cmd == _cmdAdd) {
            String str = ((TextBox)d).getString();
            if(d.getTitle().startsWith("Fordon")) {
              if(str.length() != 0) {
                ((DriveReporter)_cl).addVehicle(str);
              }
            }
            else { // Brnsle
              if(str.length() != 0) {
                ((DriveReporter)_cl).addFuel(str);
              }
            }
          }
          else if(cmd == _cmdCancel) {
            
          }
          _display.setCurrent(_frmRefuel);
        }
      });
      _display.setCurrent(tbAdd);
    } 
  }
  
  public void reloadFuels(Vector fuelIds) {
    _chgFId.deleteAll();
    int noOfItems = fuelIds.size();
    _fids = new int[noOfItems];
    int nFIdCount = 0;
    for(int i = 0, id; i < noOfItems; ++i) {
      id = ((Integer)fuelIds.elementAt(i)).intValue();
      Fuel item = (Fuel)((DriveReporter)_cl)._rmsdbFuel.getRecord(id);
      _fids[i] = item.getDRId();
      _chgFId.append(item.getFuel(), null);
      if(item.getInDB()) {
        ++nFIdCount;
      }
    }
    ((DriveReporter)_cl).setFIdCount(nFIdCount);
  }
  
  public void reloadVehicles(Vector vehicleIds) {
    _chgVId.deleteAll();
    ((DriveReporter)_cl)._frmDrive._chgVId.deleteAll();
    int noOfItems = vehicleIds.size();
    for(int i = 0, id; i < noOfItems; ++i) {
      id = ((Integer)vehicleIds.elementAt(i)).intValue();
      Vehicle item = (Vehicle)((DriveReporter)_cl)._rmsdbVehicle.getRecord(id);
      _chgVId.append(item.getVehicle(), null);
      ((DriveReporter)_cl)._frmDrive._chgVId.append(item.getVehicle(), null);
    }
    _chgVId.setSelectedIndex(_chgVId.size()-1, true);
    ((DriveReporter)_cl)._frmDrive._chgVId.setSelectedIndex(_chgVId.size()-1, true);
  }
}