package dr.rms;
import javax.microedition.rms.*;

public class RMSManager  {
  RecordStore db = null;
  String fileName;
  RecordComparator rc = null;
  RecordFilter rf = null;
  
  public RMSManager(String fileName, RecordComparator rc, RecordFilter filter) {
    this.fileName = fileName;
    this.rc = rc;
    this.rf = filter;
  }
  
  public void openDB() {
    try {
      db = RecordStore.openRecordStore(fileName, true);
    } catch(RecordStoreException e) {e.printStackTrace();}
  }
  
  public void closeDB() throws RecordStoreNotOpenException, RecordStoreException {
    if(db.getNumRecords() == 0) {
      String fileName = db.getName();
      db.closeRecordStore();
      RecordStore.deleteRecordStore(fileName);
    }
    else {
      db.closeRecordStore();
    }
  }
  
  public synchronized int insertRecord(byte[] bytes) {
    try {
      return db.addRecord(bytes, 0, bytes.length);
    }
    catch(RecordStoreException e) {
      e.printStackTrace();
    }
    return -1;
  }
  
  public synchronized void updateRecord(int id, byte[] bytes) {
    try {
      db.setRecord(id, bytes, 0, bytes.length);
    }
    catch(RecordStoreException e) {
      e.printStackTrace();
    }
  }
  
  public synchronized void deleteRecord(int id) {
    try {
      db.deleteRecord(id);
    }
    catch(RecordStoreException e) {
      e.printStackTrace();
    }
  }
  
/*
  public synchronized byte[] getRecord(int id) {
    try {
      return db.getRecord(id);
    }
    catch(RecordStoreException e) {
      e.printStackTrace();
    }
    return null;
  }
*/
  
  public synchronized void getRecord(int id, byte[] bytes) {
    try {
      db.getRecord(id, bytes, 0);
    }
    catch(RecordStoreException e) {
      e.printStackTrace();
    }
  }
  
  public void cleanUp() throws RecordStoreNotFoundException, RecordStoreException {
    this.closeDB();
    RecordStore.deleteRecordStore(fileName);
    this.openDB();
  }
  
  public void removeDB() {
    try {
      this.closeDB();
      RecordStore.deleteRecordStore(fileName);
    }
    catch(RecordStoreNotFoundException e) {
      System.out.println("RecordStoreNotFoundException..." + e);
    }
    catch(RecordStoreException e) {
      System.out.println("RecordStoreException..." + e);
    }
  }
  
  public synchronized RecordEnumeration enumerate() throws RecordStoreNotOpenException {
    return db.enumerateRecords(rf, rc, false);
  }
  
  public void setFilter(RecordFilter filter) {
    this.rf = filter;
  }
}