package dr.rms.stream;
import dr.midlet.DRItem;
import javax.microedition.rms.*;
import dr.midlet.City;

public class RMSManagerCity extends RMSManagerStream {
  public RMSManagerCity(String fileName, RecordComparator rc, RecordFilter filter) {
    super(fileName, rc, filter, 50);
  }
  
  public synchronized int insertRecord(DRItem record) {
    return super.insertRecord(writeDataTypes((City)record));
  }
 
  public synchronized void updateRecord(int id, DRItem record) {
    super.updateRecord(id, writeDataTypes((City)record));
  }
  
  byte[] writeDataTypes(City record) {
    byte[] bytes = null;
    try {
      outStreamBytes.reset();
      
      outStreamDataType.writeBoolean(record.getInDB());
      outStreamDataType.writeInt(record.getDRId());
      outStreamDataType.writeUTF(record.getCity());
      outStreamDataType.writeInt(record.getCId());
      
      outStreamDataType.flush();
      bytes = outStreamBytes.toByteArray();
    }
    catch(Exception e) {
      System.out.println(e.toString());
    }
    return bytes;
  }
  
  public DRItem getRecord(int id) {
    try {
      inStreamBytes.reset();
      this.getRecord(id, recData);
      
      boolean inDB = inStreamDataType.readBoolean();
      int ciid = inStreamDataType.readInt();
      String city = inStreamDataType.readUTF();
      int cid = inStreamDataType.readInt();
      City item = new City(inDB, ciid, city, cid);
      return item;
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    return null;
  }
}