package dr.rms.stream;
import dr.midlet.DRItem;
import javax.microedition.rms.*;
import dr.midlet.Company;

public class RMSManagerCompany extends RMSManagerStream {
  public RMSManagerCompany(String fileName, RecordComparator rc, RecordFilter filter) {
    super(fileName, rc, filter, 50);
  }
  
  public synchronized int insertRecord(DRItem record) {
    return super.insertRecord(writeDataTypes((Company)record));
  }
 
  public synchronized void updateRecord(int id, DRItem record) {
    super.updateRecord(id, writeDataTypes((Company)record));
  }
  
  byte[] writeDataTypes(Company record) {
    byte[] bytes = null;
    try {
      outStreamBytes.reset();
      
      outStreamDataType.writeBoolean(record.getInDB());
      outStreamDataType.writeInt(record.getDRId());
      outStreamDataType.writeUTF(record.getCompany());
      
      outStreamDataType.flush();
      bytes = outStreamBytes.toByteArray();
    }
    catch(Exception e) {
      System.out.println(e.toString());
    }
    return bytes;
  }
  
  public DRItem getRecord(int id) {
    try {
      inStreamBytes.reset();
      this.getRecord(id, recData);
      
      boolean inDB = inStreamDataType.readBoolean();
      int comid = inStreamDataType.readInt();
      String company = inStreamDataType.readUTF();
      Company item = new Company(inDB, comid, company);
      return item;
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    return null;
  }
}