package dr.rms.stream;
import dr.midlet.DRItem;
import javax.microedition.rms.*;
import dr.midlet.Country;

public class RMSManagerCountry extends RMSManagerStream {
  public RMSManagerCountry(String fileName, RecordComparator rc, RecordFilter filter) {
    super(fileName, rc, filter, 50);
  }
  
  public synchronized int insertRecord(DRItem record) {
    return super.insertRecord(writeDataTypes((Country)record));
  }
 
  public synchronized void updateRecord(int id, DRItem record) {
    super.updateRecord(id, writeDataTypes((Country)record));
  }
  
  byte[] writeDataTypes(Country record) {
    byte[] bytes = null;
    try {
      outStreamBytes.reset();
      
      outStreamDataType.writeBoolean(record.getInDB());
      outStreamDataType.writeInt(record.getDRId());
      outStreamDataType.writeUTF(record.getCountry());
      
      outStreamDataType.flush();
      bytes = outStreamBytes.toByteArray();
    }
    catch(Exception e) {
      System.out.println(e.toString());
    }
    return bytes;
  }
  
  public DRItem getRecord(int id) {
    try {
      inStreamBytes.reset();
      this.getRecord(id, recData);
      
      boolean inDB = inStreamDataType.readBoolean();
      int cid = inStreamDataType.readInt();
      String country = inStreamDataType.readUTF();
      Country item = new Country(inDB, cid, country);
      return item;
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    return null;
  }
}