package dr.rms.stream;
import dr.midlet.DRItem;
import javax.microedition.rms.*;
import dr.midlet.Drive;

public class RMSManagerDrive extends RMSManagerStream {
  public RMSManagerDrive(String fileName, RecordComparator rc, RecordFilter filter) {
    super(fileName, rc, filter, 100);
  }
  
  public synchronized int insertRecord(DRItem record) {
    return super.insertRecord(writeDataTypes((Drive)record));
  }
 
  public synchronized void updateRecord(int id, DRItem record) {
    super.updateRecord(id, writeDataTypes((Drive)record));
  }
  
  byte[] writeDataTypes(Drive record) {
    byte[] bytes = null;
    try {
      outStreamBytes.reset();
      
      outStreamDataType.writeUTF(record.getVId());
      outStreamDataType.writeShort(record.getDepCiId());
      outStreamDataType.writeLong(record.getDepMeter());
      outStreamDataType.writeLong(record.getDepTime());
      outStreamDataType.writeShort(record.getArrCiId());
      outStreamDataType.writeLong(record.getArrMeter());
      outStreamDataType.writeLong(record.getArrTime());
      outStreamDataType.writeInt(record.getMileage());
      outStreamDataType.writeInt(record.getPrId());
      outStreamDataType.writeShort(record.getComId());
      outStreamDataType.writeByte(record.getEId());
      outStreamDataType.writeUTF(record.getComment());
      
      outStreamDataType.flush();
      bytes = outStreamBytes.toByteArray();
    }
    catch(Exception e) {
      System.out.println(e.toString());
    }
    return bytes;
  }
  
  public DRItem getRecord(int id) {
    try {
      inStreamBytes.reset();
      this.getRecord(id, recData);
      String vid = inStreamDataType.readUTF();
      short depciid = inStreamDataType.readShort();
      long depmeter = inStreamDataType.readLong();
      long deptime = inStreamDataType.readLong();
      short arrciid = inStreamDataType.readShort();
      long arrmeter = inStreamDataType.readLong();
      long arrtime = inStreamDataType.readLong();
      int mileage = inStreamDataType.readInt();
      int prid = inStreamDataType.readInt();
      short comid = inStreamDataType.readShort();
      byte eid = inStreamDataType.readByte();
      String comment = inStreamDataType.readUTF();    
      Drive item = new Drive(vid, depciid, depmeter, deptime, 
        arrciid, arrmeter, arrtime, mileage, prid, 
        comid, eid, comment);
      return item;
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    return null;
  }
}