package dr.rms.stream;
import dr.midlet.DRItem;
import javax.microedition.rms.*;
import dr.midlet.Errand;

public class RMSManagerErrand extends RMSManagerStream {
  public RMSManagerErrand(String fileName, RecordComparator rc, RecordFilter filter) {
    super(fileName, rc, filter, 50);
  }
  
  public synchronized int insertRecord(DRItem record) {
    return super.insertRecord(writeDataTypes((Errand)record));
  }
 
  public synchronized void updateRecord(int id, DRItem record) {
    super.updateRecord(id, writeDataTypes((Errand)record));
  }
  
  byte[] writeDataTypes(Errand record) {
    byte[] bytes = null;
    try {
      outStreamBytes.reset();
      
      outStreamDataType.writeBoolean(record.getInDB());
      outStreamDataType.writeInt(record.getDRId());
      outStreamDataType.writeUTF(record.getErrand());
      
      outStreamDataType.flush();
      bytes = outStreamBytes.toByteArray();
    }
    catch(Exception e) {
      System.out.println(e.toString());
    }
    return bytes;
  }
  
  public DRItem getRecord(int id) {
    try {
      inStreamBytes.reset();
      this.getRecord(id, recData);
      
      boolean inDB = inStreamDataType.readBoolean();
      int eid = inStreamDataType.readInt();
      String errand = inStreamDataType.readUTF();
      Errand item = new Errand(inDB, eid, errand);
      return item;
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    return null;
  }
}