package dr.rms.stream;
import dr.midlet.DRItem;
import javax.microedition.rms.*;
import dr.midlet.Fuel;

public class RMSManagerFuel extends RMSManagerStream {
  public RMSManagerFuel(String fileName, RecordComparator rc, RecordFilter filter) {
    super(fileName, rc, filter, 50);
  }
  
  public synchronized int insertRecord(DRItem record) {
    return super.insertRecord(writeDataTypes((Fuel)record));
  }
 
  public synchronized void updateRecord(int id, DRItem record) {
    super.updateRecord(id, writeDataTypes((Fuel)record));
  }
  
  byte[] writeDataTypes(Fuel record) {
    byte[] bytes = null;
    try {
      outStreamBytes.reset();
      
      outStreamDataType.writeBoolean(record.getInDB());
      outStreamDataType.writeInt(record.getDRId());
      outStreamDataType.writeUTF(record.getFuel());
      
      outStreamDataType.flush();
      bytes = outStreamBytes.toByteArray();
    }
    catch(Exception e) {
      System.out.println(e.toString());
    }
    return bytes;
  }
  
  public DRItem getRecord(int id) {
    try {
      inStreamBytes.reset();
      this.getRecord(id, recData);
      
      boolean inDB = inStreamDataType.readBoolean();
      int fid = inStreamDataType.readInt();
      String fuel = inStreamDataType.readUTF();
      Fuel item = new Fuel(inDB, fid, fuel);
      return item;
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    return null;
  }
}