package dr.rms.stream;
import dr.midlet.DRItem;
import javax.microedition.rms.*;
import dr.midlet.Refuel;

public class RMSManagerRefuel extends RMSManagerStream {
  public RMSManagerRefuel(String fileName, RecordComparator rc, RecordFilter filter) {
    super(fileName, rc, filter, 50);
  }
  
  public synchronized int insertRecord(DRItem record) {
    return super.insertRecord(writeDataTypes((Refuel)record));
  }
 
  public synchronized void updateRecord(int id, DRItem record) {
    super.updateRecord(id, writeDataTypes((Refuel)record));
  }
  
  byte[] writeDataTypes(Refuel record) {
    byte[] bytes = null;
    try {
      outStreamBytes.reset();
      
      outStreamDataType.writeUTF(record.getVId());
      outStreamDataType.writeLong(record.getRfTime());
      outStreamDataType.writeInt(record.getPrice());
      outStreamDataType.writeInt(record.getVolume());
      outStreamDataType.writeByte(record.getLevel());
      outStreamDataType.writeByte(record.getFId());
      outStreamDataType.writeLong(record.getMeter());
      
      outStreamDataType.flush();
      bytes = outStreamBytes.toByteArray();
    }
    catch(Exception e) {
      System.out.println(e.toString());
    }
    return bytes;
  }
  
  public DRItem getRecord(int id) {
    try {
      inStreamBytes.reset();
      this.getRecord(id, recData);
      
      String vid = inStreamDataType.readUTF();
      long rftime = inStreamDataType.readLong();
      int price = inStreamDataType.readInt();
      int volume = inStreamDataType.readInt();
      byte level = inStreamDataType.readByte();
      byte fid = inStreamDataType.readByte();
      long meter = inStreamDataType.readLong();      
      Refuel item = new Refuel(vid, rftime, price, volume, level, fid, meter);
      return item;
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    return null;
  }
}