package dr.rms.stream;
import dr.midlet.DRItem;
import dr.rms.RMSManager;
import javax.microedition.rms.*;
import java.io.*;

public abstract class RMSManagerStream extends RMSManager {
  protected ByteArrayInputStream  inStreamBytes;
  protected DataInputStream       inStreamDataType;
  protected ByteArrayOutputStream outStreamBytes;
  protected DataOutputStream      outStreamDataType;
  
  protected byte[] recData;

  public RMSManagerStream(String fileName, RecordComparator rc, RecordFilter filter, int nBytes) {
    super(fileName, rc, filter);
    recData = new byte[nBytes];
    this.initOutStream();
    this.initInputStream();
  }
  
  public abstract int insertRecord(DRItem record);
  public abstract void updateRecord(int id, DRItem record);
  public abstract DRItem getRecord(int id);
  
  private void initOutStream() {
    outStreamBytes = new ByteArrayOutputStream();
    outStreamDataType = new DataOutputStream(outStreamBytes);
  }
  
  private void initInputStream() {
    inStreamBytes = new ByteArrayInputStream(recData);
    inStreamDataType = new DataInputStream(inStreamBytes);
  }
       
  public void closeDB() {
    try {
      inStreamBytes.close();
      outStreamBytes.close();
      outStreamDataType.close();
      super.closeDB();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
}