package dr.rms.stream;
import dr.midlet.DRItem;
import javax.microedition.rms.*;
import dr.midlet.Vehicle;

public class RMSManagerVehicle extends RMSManagerStream {
  public RMSManagerVehicle(String fileName, RecordComparator rc, RecordFilter filter) {
    super(fileName, rc, filter, 50);
  }
  
  public synchronized int insertRecord(DRItem record) {
    return super.insertRecord(writeDataTypes((Vehicle)record));
  }
 
  public synchronized void updateRecord(int id, DRItem record) {
    super.updateRecord(id, writeDataTypes((Vehicle)record));
  }
  
  byte[] writeDataTypes(Vehicle record) {
    byte[] bytes = null;
    try {
      outStreamBytes.reset();
      
      outStreamDataType.writeBoolean(record.getInDB());
      outStreamDataType.writeUTF(record.getVehicle());
      
      outStreamDataType.flush();
      bytes = outStreamBytes.toByteArray();
    }
    catch(Exception e) {
      System.out.println(e.toString());
    }
    return bytes;
  }
  
  public DRItem getRecord(int id) {
    try {
      inStreamBytes.reset();
      this.getRecord(id, recData);
      
      boolean inDB = inStreamDataType.readBoolean();
      String vehicle = inStreamDataType.readUTF();
      Vehicle record = new Vehicle(inDB, vehicle);
      return record;
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    return null;
  }
}